﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using Microsoft.Win32;
using System.Runtime.InteropServices;

namespace dictionary
{
    public partial class Form1 : Form
    {
        private spellcheck spell;
        private String mode;
        private dict dict_list;
        private infoDialog infodlg;
        private spelldlg sdlg;
        //private settingsForm settingsDialog;
        private simpleconfig c;
        public int showicon;
        public const int WM_NCLBUTTONDOWN = 0xA1;
        public const int HT_CAPTION = 0x2;
        [DllImportAttribute("user32.dll")]
        public static extern int SendMessage(IntPtr hWnd, int Msg, int wParam, int lParam);
        [DllImportAttribute("user32.dll")]
        public static extern bool ReleaseCapture();

        public Form1()
        {
            c = new simpleconfig("settings.txt");
            //EventHandler info_click = new EventHandler(OnClick);;
            InitializeComponent();
            infodlg = new infoDialog(int.Parse(c.get("dbgcol")), int.Parse(c.get("dtxtcol")));
            sdlg = new spelldlg();
            dict_list = new dict("dict.txt");
            spell = new spellcheck(dict_list);
            this.ControlBox = false;
            this.Text = string.Empty;
            this.FormBorderStyle = FormBorderStyle.FixedSingle;
            this.TopMost = true;
            mode = "Dictionary";
            closeButton.BackColor = Color.Red;
            hideButton.BackColor = Color.Blue;
            SetStyle(ControlStyles.SupportsTransparentBackColor, true);
            this.BackColor = Color.Transparent;
            this.Focus();
            Hotkey hk = new Hotkey();
            hk.KeyCode = Keys.A;
            hk.Windows = true;
            hk.Pressed += delegate { this.Activate(); searchTextBox.Clear();
                this.WindowState = FormWindowState.Normal;
                this.Show();  searchTextBox.Focus(); };
            hk.Register(this);
            infodlg.Show();
            infodlg.Hide();
        }

        public void load_settings()
        {
            this.Location = new Point(int.Parse(c.get("PX")), int.Parse(c.get("PY")));
            showicon = int.Parse(c.get("task"));
            if (showicon == 0)
                this.ShowInTaskbar = false;
            else
                this.ShowInTaskbar = true;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            load_settings();
        }

        private void Form1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                //Console.Out.WriteLine(this.Location.X,this.Location.Y);
                ReleaseCapture();
                SendMessage(Handle, WM_NCLBUTTONDOWN, HT_CAPTION, 0);
                if(mode == "Dictionary")
                    infodlg.setPos(this.Location.X, this.Location.Y - infodlg.Size.Height);
            }
        }

        private void searchButton_Click(object sender, EventArgs e)
        {

        }

        private void searchTextBox_TextChanged(object sender, EventArgs e)
        {
            if (mode == "Dictionary")
            {
                sdlg.Hide();
                String wrd = searchTextBox.Text.ToUpper();
                if (this.dict_list.word_exist(wrd))
                {
                    infodlg.Show();
                    infodlg.setPos(this.Location.X, this.Location.Y - infodlg.Size.Height);
                    infodlg.setLabels(wrd, dict_list.get_def(wrd), dict_list.get_speech(wrd));
                    this.Focus();
                }
                else
                    infodlg.Hide();
            }
        }

        private void closeButton_Click(object sender, EventArgs e)
        {
            c.set("PX", (this.Location.X ).ToString());
            c.set("PY", (this.Location.Y ).ToString());
            Application.Exit();
        }

        private void settingsButton_Click(object sender, EventArgs e)
        {
            settingsForm settingsDialog = new settingsForm();
            settingsDialog.ShowDialog();
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            //If possible focus on key press
        }

        private void Form1_Deactivate(object sender, EventArgs e)
        {
        }

        private void searchTextBox_Enter(object sender, EventArgs e)
        {
            //searchTextBox.Text = "";
        }

        private void searchTextBox_Leave(object sender, EventArgs e)
        {
            infodlg.Hide();
            sdlg.Hide();
        }

        private void Form1_Leave(object sender, EventArgs e)
        {

        }

        private void searchTextBox_KeyDown(object sender, KeyEventArgs e)
        {

        }

        private void hideButton_Click(object sender, EventArgs e)
        {
            if (infodlg.Visible == false)
                //    searchTextBox.Text = "";
                this.WindowState = FormWindowState.Minimized;
        }

        private void searchTextBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return)
            {
                List<String> corrections = new List<String>();
                corrections = spell.check_word(searchTextBox.Text);
                sdlg.setCorrections(corrections);
                sdlg.Show();
                sdlg.setPos(this.Location.X, this.Location.Y - sdlg.Size.Height);
                e.Handled = true;
            }
        }


    }
}
