﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.InteropServices;

namespace dictionary
{
    public class dict
    {
        private Dictionary<String, word> dictHash = new Dictionary<String, word>();

        public dict(String f_txt)
        {
            //Check to see hash table file is there if not load one in and save it as file
            if (!File.Exists("bdict.dat"))
            {
                try
                {
                    using (StreamReader sr = new StreamReader(f_txt))
                    {
                        String line;
                        //Add word entry letter by letter until it sees a space
                        while ((line = sr.ReadLine()) != null)
                        {
                            word entry = new word();
                            int index = 0;
                            String wrd = "";
                            do
                            {
                                wrd += line[index];
                                index += 1;
                            }
                            while (line[index] != ' ');
                            entry.set_entry(wrd);
                            //Add definition to the word
                            int defIndex = index;
                            String def = "";
                            do
                            {
                                if (line[index] == '<' || line[index] == '>' || line[index] == '{' || line[index] == '}')
                                    index += 1;
                                if (line[index] == '=')
                                {
                                    do
                                        index += 1;
                                    while (line[index] != '>' && line[index] != '}');
                                    index += 1;
                                }
                                def += line[index];
                                index += 1;
                            } while (line[index] != '[');
                            index += 1;
                            entry.set_def(def);
                            String speech = "";
                            do
                            {
                                speech += line[index];
                                index += 1;
                            } while (line[index] != ' ' && line[index] != ']');
                            entry.set_speech(speech);
                            //TODO: Add suffixes
                            //Add to dictionary
                            dictHash[wrd] = entry;
                        }
                    }
                }
                catch (Exception e)
                {
                    Console.Out.WriteLine(e.StackTrace);
                }
                try
                {
                    //Save
                    Stream fs = File.Open("bdict.dat", FileMode.Create);
                    BinaryFormatter bf = new BinaryFormatter();
                    BinaryWriter bw = new BinaryWriter(fs);
                    bw.Write(dictHash.Count);
                    foreach (var entity in dictHash)
                    {
                        bw.Write(entity.Key);
                        bw.Write(entity.Value.get_entry());
                        bw.Write(entity.Value.get_def());
                        bw.Write(entity.Value.get_speech());
                    }
                    bw.Flush();
                    fs.Close();
                }
                catch (Exception e)
                {
                    Console.Out.WriteLine(e.StackTrace);
                }
            }
            else
            {
                Stream fs = File.Open("bdict.dat", FileMode.Open);
                BinaryReader br = new BinaryReader(fs);
                int count = br.ReadInt32();
                this.dictHash = new Dictionary<String, word>(count);
                for( int i=0; i < count; i++)
                {
                    String key = br.ReadString();
                    String entry = br.ReadString();
                    String def = br.ReadString();
                    String speech = br.ReadString();
                    word value = new word(entry,def,speech);
                    this.dictHash.Add(key, value);
                }

            }
        }

        public bool word_exist(String wrd)
        {
            return dictHash.ContainsKey(wrd);
        }

        public void test(String key)
        {
            MessageBox.Show(dictHash[key].get_def());
        }

        public String get_def(String wrd)
        {
            return dictHash[wrd].get_def();
        }

        public String get_speech(String wrd)
        {
            return dictHash[wrd].get_speech();
        }
    }
}