﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using Microsoft.Win32;

namespace dictionary
{
    public partial class infoDialog : Form
    {
        private Label wordLabel;
        private Label defLabel;
        private Label speechLabel;

        public infoDialog(int bgcol, int txtcol)
        {
            this.ControlBox = false;
            this.Text = string.Empty;
            this.FormBorderStyle = FormBorderStyle.FixedSingle;
            this.TopMost = true;
            this.Capture = false;
            this.ShowInTaskbar = false;
            this.BackColor = int_to_col(bgcol);
            this.Size = new Size(250,100);

            wordLabel = new Label();
            defLabel = new Label();
            speechLabel = new Label();
       
            wordLabel.Location = new Point(0,0);
            defLabel.Location = new Point(0,32);

            wordLabel.ForeColor = int_to_col(txtcol);
            defLabel.ForeColor = int_to_col(txtcol);
            speechLabel.ForeColor = int_to_col(txtcol);

            wordLabel.AutoSize = true;
            defLabel.AutoSize = true;
            speechLabel.AutoSize = true;

            wordLabel.Font = new Font("Times New Roman", 16, FontStyle.Bold);
            speechLabel.Font = new Font("Times New Roman",12,FontStyle.Italic);

            Controls.Add(wordLabel);
            Controls.Add(defLabel);
            Controls.Add(speechLabel);

            this.Click += new EventHandler(offview);
        }

        private void offview(Object sender, EventArgs e)
        {
            this.Hide();
        }

        private Color int_to_col(int icol)
        {
            Color rel_col = Color.FromArgb(icol);
            int r = rel_col.R;
            int g = rel_col.G;
            int b = rel_col.B;
            return Color.FromArgb(r, g, b);
        }

        public void setLabels(String wrd, String def, String speech)
        {
            wordLabel.Text = wrd;
            defLabel.Text = def;
            speechLabel.Text = "[" + speech + "]";
            speechLabel.Location = new Point(defLabel.Size.Width + 10,0);
        }

        public void setPos(int x, int y)
        {
            this.Location = new Point(x, y);
        }
    }
}