﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace dictionary
{
    public partial class settingsForm : Form
    {
        simpleconfig c;
        Color bgdict_sel_col;
        Color txtdict_sel_col;
        //private Form1 formdata;

        public settingsForm()
        {
            c = new simpleconfig("settings.txt");
            InitializeComponent();
            if (c.get("task") == "1")
                taskbarCheck.CheckState = CheckState.Checked;
            else
                taskbarCheck.CheckState = CheckState.Unchecked;
            //testLabel.BackColor = Color.FromArgb(int.Parse(c.get("dbgcol")));
            bgdict_sel_col = int_to_col(int.Parse(c.get("dbgcol")));
            txtdict_sel_col = int_to_col(int.Parse(c.get("dtxtcol")));
            testLabel.BackColor = bgdict_sel_col;
            testLabel.ForeColor = txtdict_sel_col;
            //testLabel.ForeColor = Color.FromArgb(int.Parse(c.get("dtxtcol")));
        }

        private Color int_to_col(int icol)
        {
            Color rel_col = Color.FromArgb(icol);
            int r = rel_col.R;
            int g = rel_col.G;
            int b = rel_col.B;
            return Color.FromArgb(r, g, b);
        }

        private void okButton_Click(object sender, EventArgs e)
        { 
            if (taskbarCheck.Checked)
                c.set("task", "1");
            else
                c.set("task", "0");
            if (bgdict_sel_col != null)
                c.set("dbgcol", bgdict_sel_col.ToArgb().ToString());
            if (txtdict_sel_col != null)
                c.set("dtxtcol", txtdict_sel_col.ToArgb().ToString());
            this.Hide();
            Application.Restart();
        }

        private void bgdictButton_Click(object sender, EventArgs e)
        {
            if (bgcolor.ShowDialog() == DialogResult.OK)
            {
                testLabel.BackColor = bgcolor.Color;
                bgdict_sel_col = bgcolor.Color;
            }
        }

        private void txtcolButton_Click(object sender, EventArgs e)
        {
            if (dtxtcol.ShowDialog() == DialogResult.OK)
            {
                testLabel.ForeColor = dtxtcol.Color;
                txtdict_sel_col = dtxtcol.Color;
            }
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            this.Hide();
        }
    }
}
