﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace dictionary
{
    class spellcheck
    {
        private dict word_list;
        private String alpha;
        public spellcheck(dict _word_list)
        {
            word_list = _word_list;
            alpha = "abcdefghijklmnopqrstuvwxyz";
        }

        public List<String> check_word(String wrd)
        {
            List<String> results = new List<String>();
            List<List<String>> splits = new List<List<String>>();
            //Already exists?
            if (word_list.word_exist(wrd.ToUpper()))
            {
                results.Add("SPELLING CORRECT");
                return results;
            }
            int index_length = wrd.Length;
            for (int i = 0; i < wrd.Length; i++)
            {
                List<String> tmp_split = new List<String>();
                tmp_split.Add(wrd.Substring(0,i));
                tmp_split.Add(wrd.Substring(i,index_length-i));
                splits.Add(tmp_split);
            }
            //Deletes
            for (int i = 0; i < wrd.Length; i++)
                if (i >= wrd.Length-1)
                    results.Add(wrd.Substring(0,i)+wrd.Substring(i,0));
                else
                    results.Add(wrd.Substring(0, i) + wrd.Substring(i + 1, (index_length-1) - i));
            //Transposes
            for (int i = 0; i < wrd.Length; i++)
            {
                List<String> tmpsplit = splits[i];
                if (tmpsplit[1].Length > 1)
                    results.Add(tmpsplit[0] + tmpsplit[1][1] + tmpsplit[1][0] + tmpsplit[1].Substring(2));
            }
            //Replaces
            for (int i = 0; i < wrd.Length; i++)
            {
                List<String> tmpsplit = splits[i];
                for (int j = 0; j < alpha.Length; j++)
                    results.Add( tmpsplit[0] + alpha[j] + tmpsplit[1].Substring(1));
            }
            //Inserts
            for (int i = 0; i < wrd.Length; i++)
            {
                List<String> tmpsplit = splits[i];
                for (int j = 0; j < alpha.Length; j++)
                    results.Add(tmpsplit[0] + alpha[j] + tmpsplit[1]);
            }
            //Check existing
            List<String> final = new List<String>(); 
            for (int i = 0; i < results.Count; i++)
                if (word_list.word_exist(results[i].ToUpper()))
                    final.Add(results[i]);   
            return final;
        }
    }
}
