﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using Microsoft.Win32;

namespace dictionary
{
    public partial class spelldlg : Form
    {
        ListBox candidatesBox;
        public spelldlg()
        {
            candidatesBox = new ListBox();
            this.ControlBox = false;
            this.Text = string.Empty;
            this.FormBorderStyle = FormBorderStyle.FixedSingle;
            this.TopMost = true;
            this.Capture = false;
            this.ShowInTaskbar = false;
            this.Controls.Add(candidatesBox);
            this.Size = candidatesBox.Size;
            candidatesBox.Click += new EventHandler(copyWord);
            candidatesBox.KeyPress += new KeyPressEventHandler(copyWordonEnter);

        }

        public void setList(List<String> corrections)
        {
            candidatesBox.Items.Clear();
            if (corrections.Count > 0)
            {
                if (corrections[0] != "SPELLING CORRECT")
                {
                    for (int i = 0; i < corrections.Count(); i++)
                        candidatesBox.Items.Add(corrections[i]);
                    candidatesBox.Items.Add("None Above");
                }
                else
                    candidatesBox.Items.Add("Entry Correct");
            }
            else
                candidatesBox.Items.Add("None Above");
        }

        private void copyWordonEnter(Object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return)
            {
                if (candidatesBox.SelectedItem.ToString() != "None Above" && candidatesBox.SelectedItem.ToString() != "Entry Correct")
                    Clipboard.SetText(candidatesBox.SelectedItem.ToString());
                e.Handled = true;
                this.Hide();
            }
        }

        private void copyWord(Object sender, EventArgs e)
        {
            if (candidatesBox.SelectedItem.ToString() != "None Above" && candidatesBox.SelectedItem.ToString() != "Entry Correct")
                Clipboard.SetText(candidatesBox.SelectedItem.ToString());
            this.Hide();
        }

        public void setCorrections(List<String> corrections)
        {
            setList(corrections);
        }

        public void setPos(int x, int y)
        {
            this.Location = new Point(x, y);
        }
    }
}
